]>
git.ipfire.org Git - thirdparty/git.git/blob - git-cvsexportcommit.perl
5 use File
:: Temp
qw(tempdir) ;
7 use File
:: Basename
qw(basename dirname) ;
11 our ( $opt_h , $opt_P , $opt_p , $opt_v , $opt_c , $opt_f , $opt_a , $opt_m , $opt_d , $opt_u , $opt_w , $opt_W , $opt_k );
13 getopts
( 'uhPpvcfkam:d:w:W' );
17 die "Need at least one commit identifier!" unless @ARGV ;
19 # Get git-config settings
20 my $repo = Git
-> repository ();
21 $opt_w = $repo -> config ( 'cvsexportcommit.cvsdir' ) unless defined $opt_w ;
23 if ( $opt_w || $opt_W ) {
24 # Remember where GIT_DIR is before changing to CVS checkout
25 unless ( $ENV { GIT_DIR
}) {
26 # No GIT_DIR set. Figure it out for ourselves
27 my $gd = `git-rev-parse --git-dir` ;
31 # Make sure GIT_DIR is absolute
32 $ENV { GIT_DIR
} = File
:: Spec
-> rel2abs ( $ENV { GIT_DIR
});
36 if (! - d
$opt_w . "/CVS" ) {
37 die " $opt_w is not a CVS checkout" ;
39 chdir $opt_w or die "Cannot change to CVS checkout at $opt_w " ;
41 unless ( $ENV { GIT_DIR
} && - r
$ENV { GIT_DIR
}){
42 die "GIT_DIR is not defined or is unreadable" ;
48 @cvs = ( 'cvs' , '-d' , $opt_d );
53 # resolve target commit
56 $commit = safe_pipe_capture
( 'git-rev-parse' , '--verify' , " $commit ^0" );
59 die "The commit reference $commit did not resolve!" ;
62 # resolve what parent we want
66 $parent = safe_pipe_capture
( 'git-rev-parse' , '--verify' , " $parent ^0" );
69 die "The parent reference did not resolve!" ;
73 # find parents from the commit itself
74 my @commit = safe_pipe_capture
( 'git-cat-file' , 'commit' , $commit );
78 my $stage = 'headers' ; # headers, msg
82 foreach my $line ( @commit ) {
84 if ( $stage eq 'headers' && $line eq '' ) {
89 if ( $stage eq 'headers' ) {
90 if ( $line =~ m/^parent (\w{40})$/ ) { # found a parent
92 } elsif ( $line =~ m/^author (.+) \d+ [-+]\d+$/ ) {
94 } elsif ( $line =~ m/^committer (.+) \d+ [-+]\d+$/ ) {
105 my $noparent = "0000000000000000000000000000000000000000" ;
108 # double check that it's a valid parent
109 foreach my $p ( @parents ) {
115 die "Did not find $parent in the parents for this commit!" if ! $found and ! $opt_P ;
116 } else { # we don't have a parent from the cmdline...
117 if ( @parents == 1 ) { # it's safe to get it from the commit
118 $parent = $parents [ 0 ];
119 } elsif ( @parents == 0 ) { # there is no parent
121 } else { # cannot choose automatically from multiple parents
122 die "This commit has more than one parent -- please name the parent you want to use explicitly" ;
129 $opt_v && print "Resetting to $parent \n " ;
130 $go_back_to = `git symbolic-ref HEAD 2> /dev/null ||
131 git rev-parse HEAD` || die "Could not determine current branch" ;
132 system ( "git checkout -q $parent ^0" ) && die "Could not check out $parent ^0" ;
135 $opt_v && print "Applying to CVS commit $commit from parent $parent \n " ;
137 # grab the commit message
138 open ( MSG
, ">.msg" ) or die "Cannot open .msg for writing" ;
144 print MSG
" \n\n Author: $author \n " ;
145 if ( $author ne $committer ) {
146 print MSG
"Committer: $committer \n " ;
151 if ( $parent eq $noparent ) {
152 `git-diff-tree --binary -p --root $commit >.cvsexportcommit.diff` ; # || die "Cannot diff";
154 `git-diff-tree --binary -p $parent $commit >.cvsexportcommit.diff` ; # || die "Cannot diff";
157 ## apply non-binary changes
159 # In pedantic mode require all lines of context to match. In normal
160 # mode, be compatible with diff/patch: assume 3 lines of context and
161 # require at least one line match, i.e. ignore at most 2 lines of
162 # context, like diff/patch do by default.
163 my $context = $opt_p ?
'' : '-C1' ;
165 print "Checking if patch will apply \n " ;
168 open APPLY
, "GIT_DIR= git-apply $context --summary --numstat<.cvsexportcommit.diff|" || die "cannot patch" ;
170 close APPLY
|| die "Cannot patch" ;
171 my ( @bfiles , @files , @afiles , @dfiles );
174 push ( @bfiles , $1 ) if m/^-\t-\t(.*)$/ ;
175 push ( @files , $1 ) if m/^-\t-\t(.*)$/ ;
176 push ( @files , $1 ) if m/^\d+\t\d+\t(.*)$/ ;
177 push ( @afiles , $1 ) if m/^ create mode [0-7]+ (.*)$/ ;
178 push ( @dfiles , $1 ) if m/^ delete mode [0-7]+ (.*)$/ ;
180 map { s/^"(.*)"$/$1/g } @bfiles , @files ;
181 map { s/\\([0-7]{3})/sprintf('%c',oct $1)/eg } @bfiles , @files ;
183 # check that the files are clean and up to date according to cvs
186 foreach my $p ( @afiles ) {
187 my $path = dirname
$p ;
188 while (!- d
$path and ! grep { $_ eq $path } @dirs ) {
189 unshift @dirs , $path ;
190 $path = dirname
$path ;
195 foreach my $d ( @dirs ) {
198 warn " $d exists and is not a directory! \n " ;
202 # ... query status of all files that we have a directory for and parse output of 'cvs status' to %cvsstat.
204 foreach my $f ( @files ) {
205 my $path = dirname
$f ;
206 next if ( grep { $_ eq $path } @dirs );
207 push @canstatusfiles , $f ;
211 if ( @canstatusfiles ) {
213 my @updated = xargs_safe_pipe_capture
([ @cvs , 'update' ], @canstatusfiles );
216 # "cvs status" reorders the parameters, notably when there are multiple
217 # arguments with the same basename. So be precise here.
219 my %added = map { $_ => 1 } @afiles ;
220 my %todo = map { $_ => 1 } @canstatusfiles ;
223 my @canstatusfiles2 = ();
225 foreach my $name ( keys %todo ) {
226 my $basename = basename
( $name );
228 # CVS reports files that don't exist in the current revision as
229 # "no file $basename" in its "status" output, so we should
230 # anticipate that. Totally unknown files will have a status
231 # "Unknown". However, if they exist in the Attic, their status
232 # will be "Up-to-date" (this means they were added once but have
234 $basename = "no file $basename " if $added { $basename };
236 $basename =~ s/^\s+// ;
237 $basename =~ s/\s+$// ;
239 if (! exists ( $fullname { $basename })) {
240 $fullname { $basename } = $name ;
241 push ( @canstatusfiles2 , $name );
242 delete ( $todo { $name });
246 @cvsoutput = xargs_safe_pipe_capture
([ @cvs , 'status' ], @canstatusfiles2 );
247 foreach my $l ( @cvsoutput ) {
250 my ( $file , $status ) = $l =~ /^File:\s+(.*\S)\s+Status: (.*)$/ ;
252 my $fullname = $fullname { $file };
253 print STDERR
"Huh? Status ' $status ' reported for unexpected file ' $file ' \n "
254 unless defined $fullname ;
256 # This response means the file does not exist except in
257 # CVS's attic, so set the status accordingly
259 if $file =~ /^no file /
260 && $status eq 'Up-to-date' ;
262 $cvsstat { $fullname { $file }} = $status
263 if defined $fullname { $file };
268 # ... Validate that new files have the correct status
269 foreach my $f ( @afiles ) {
270 next unless defined ( my $stat = $cvsstat { $f });
272 # This means the file has never been seen before
273 next if $stat eq 'Unknown' ;
275 # This means the file has been seen before but was removed
276 next if $stat eq 'In-attic' ;
279 warn "File $f is already known in your CVS checkout -- perhaps it has been added by another user. Or this may indicate that it exists on a different branch. If this is the case, use -f to force the merge. \n " ;
280 warn "Status was: $cvsstat { $f } \n " ;
283 # ... validate known files.
284 foreach my $f ( @files ) {
285 next if grep { $_ eq $f } @afiles ;
286 # TODO:we need to handle removed in cvs
287 unless ( defined ( $cvsstat { $f }) and $cvsstat { $f } eq "Up-to-date" ) {
289 warn "File $f not up to date but has status ' $cvsstat { $f }' in your CVS checkout! \n " ;
292 # Depending on how your GIT tree got imported from CVS you may
293 # have a conflict between expanded keywords in your CVS tree and
294 # unexpanded keywords in the patch about to be applied.
296 my $orig_file = " $f .orig" ;
297 rename $f , $orig_file ;
298 open ( FILTER_IN
, "< $orig_file " ) or die "Cannot open $orig_file \n " ;
299 open ( FILTER_OUT
, "> $f " ) or die "Cannot open $f \n " ;
303 $line =~ s/\$([A-Z][a-z]+):[^\$]+\$/\$$1\$/g ;
304 print FILTER_OUT
$line ;
312 if ( $opt_f ) { warn "The tree is not clean -- forced merge \n " ;
315 die "Exiting: your CVS tree is not clean for this merge." ;
321 system ( "git checkout -q $commit ^0" ) && die "cannot patch" ;
323 `GIT_DIR= git-apply $context --summary --numstat --apply <.cvsexportcommit.diff` || die "cannot patch" ;
326 print "Patch applied successfully. Adding new files and directories to CVS \n " ;
330 # We have to add the directories in order otherwise we will have
331 # problems when we try and add the sub-directory of a directory we
332 # have not added yet.
334 # Luckily this is easy to deal with by sorting the directories and
335 # dealing with the shortest ones first.
337 @dirs = sort { length $a <=> length $b } @dirs ;
339 foreach my $d ( @dirs ) {
340 if ( system ( @cvs , 'add' , $d )) {
342 warn "Failed to cvs add directory $d -- you may need to do it manually" ;
346 foreach my $f ( @afiles ) {
347 if ( grep { $_ eq $f } @bfiles ) {
348 system ( @cvs , 'add' , '-kb' , $f );
350 system ( @cvs , 'add' , $f );
354 warn "Failed to cvs add $f -- you may need to do it manually" ;
358 foreach my $f ( @dfiles ) {
359 system ( @cvs , 'rm' , '-f' , $f );
362 warn "Failed to cvs rm -f $f -- you may need to do it manually" ;
366 print "Commit to CVS \n " ;
367 print "Patch title (first comment line): $title \n " ;
368 my @commitfiles = map { unless ( m/\s/ ) { ' \' ' . $_ . ' \' ' ; } else { $_ ; }; } ( @files );
369 my $cmd = join ( ' ' , @cvs ). " commit -F .msg @commitfiles " ;
372 print "NOTE: One or more hunks failed to apply cleanly. \n " ;
373 print "You'll need to apply the patch in .cvsexportcommit.diff manually \n " ;
374 print "using a patch program. After applying the patch and resolving the \n " ;
375 print "problems you may commit using:" ;
376 print " \n cd \" $opt_w \" " if $opt_w ;
378 print " \n git checkout $go_back_to \n " if $go_back_to ;
384 print "Autocommit \n $cmd \n " ;
385 print xargs_safe_pipe_capture
([ @cvs , 'commit' , '-F' , '.msg' ], @files );
387 die "Exiting: The commit did not succeed" ;
389 print "Committed successfully to CVS \n " ;
393 print "Ready for you to commit, just run: \n\n $cmd \n " ;
397 unlink ( ".cvsexportcommit.diff" );
400 system ( "git checkout $go_back_to " ) && die "cannot move back to $go_back_to " ;
401 if (!( $go_back_to =~ /^[0-9a-fA-F]{40}$/ )) {
402 system ( "git symbolic-ref HEAD $go_back_to " ) &&
403 die "cannot move back to $go_back_to " ;
407 # CVS version 1.11.x and 1.12.x sleeps the wrong way to ensure the timestamp
408 # used by CVS and the one set by subsequence file modifications are different.
409 # If they are not different CVS will not detect changes.
414 Usage: GIT_DIR=/path/to/.git git cvsexportcommit [-h] [-p] [-v] [-c] [-f] [-u] [-k] [-w cvsworkdir] [-m msgprefix] [ parent ] commit
419 # An alternative to `command` that allows input to be passed as an array
420 # to work around shell problems with weird characters in arguments
421 # if the exec returns non-zero we die
422 sub safe_pipe_capture
{
424 if ( my $pid = open my $child , '-|' ) {
425 @output = (< $child >);
426 close $child or die join ( ' ' , @_ ). ": $! $?" ;
428 exec ( @_ ) or die "$! $?" ; # exec() can fail the executable can't be found
430 return wantarray ?
@output : join ( '' , @output );
433 sub xargs_safe_pipe_capture
{
434 my $MAX_ARG_LENGTH = 65536 ;
441 while ( @_ && $length < $MAX_ARG_LENGTH ) {
443 $length += length ( $args [ $#args ]);
446 push @output , safe_pipe_capture
( @
$cmd , @args );
449 $output .= safe_pipe_capture
( @
$cmd , @args );
452 return wantarray ?
@output : $output ;